from aga import problem
from aga.score import prize
from aga.injection import (uses_recursion_t_case,
                           uses_recursion_t_cases,
                           award_prize)
import sys
import random 

sys.setrecursionlimit(10000)
random.seed(423)


def random_int_digits(digits):
    return random.randint(10**(digits-1), 10**digits-1)


_ri = random.randint


@uses_recursion_t_cases((random_int_digits(_ri(1, 4)) for _ in range(7)),
                           aga_value=0, aga_weight=0, aga_hidden=True)

@uses_recursion_t_case(6, aga_expect=9)
@uses_recursion_t_case(1, aga_expect=1)
@uses_recursion_t_case(5, aga_expect=6)
@prize(award_prize, name="Autograder Score", value=20, weight=0)
@problem()
def collatz_length(n):
    if n == 1:
        return 1
    elif n % 2 == 0:
        return 1 + collatz_length(n // 2)
    else:
        return 1 + collatz_length(3 * n + 1)
